// "namer.C"

/*    Copyright (C) 1994,1995,1996  Steve Hardt

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    George Caswell
    timbuktu@wpi.edu
    http://adamant.res.wpi.net/~timbuktu/xevil

For the original xevil and new 2.0 versions-

    Steve Hardt
    satan@xevil.com
    http://www.xevil.com
*/

#ifndef NO_PRAGMAS
#pragma implementation "namer.h"
#endif

#include "namer.h"
#include "utils.h"

char *Namer::wittySayings[] = {
  "If it moves it's a threat.  If it doesn't move it's a potential threat.",
    "Happy, happy.  Joy, joy.",
    "For the mother country!!!",
    "Hi ho.  Hi ho.  It's off to kill we go.",
    "Well, do you feel lucky, Punk?",
    "Wake up, time to die.",
    "Let's rock.",
    "I love the smell of napalm in the morning.",
    "How's it feel to be hunted?",
    "Go ahead, make my day.",
    "I'll be back.",
    "Won't you be my neighbor?",
    "3E.  We bring good things to death.",
    "We come in peace.  (Shoot to kill.  Shoot to kill.)",
    "Hey.  You can't do that.",
    "I'm here to chew bubble-gum and kick ass.  And I'm all out of bubble-gum.",
    "You're a useless asshole, Pogo-Man.",
    "Settle down, Beavis.",
    "Now I have a machine gun.  Ho, Ho, Ho.",
    "Aren't you dead yet?",
    "I don't give a fuck what you know.  I'm going to torture you anyway.",
    "I'm hungry.  Let's get a taco.",
    "I'm sorry, Dave.  I can't do that.",
    "Violence is the only true form of communication.",
    "Let the flames purify your soul!!!",
    "Fuck me gently with a chainsaw.",
    "He doesn't look like a quivering ball of white-hot canine fury.",
    "Hackito ergo sum.",
    "I'm singing in the rain...",
    "Washin' the dog!!  Washin' the dog!!",
    "ooooh.  That's gotta hurt.",
    "Kids, don't try this at home.  We're trained professionals.",
    "Oh, you want some of this?!  Fuck you!",
    "Well, he shoulda' armed himself!",
    "Fuck art.  Let's kill.",
    "If you can't eat it or fuck it, kill it.",
    "Skrotus lives in my fridge.",
    "I love you.  You love me.  We're a happy family.",
    "You always were an asshole, Gorman.",
    "Change it dude.  This sucks.",
    "The game of death, doom, and (more or less) ultimate destruction.",
    "I think I'll just Dieeeeeee.",
    "You know he'll feel that one in the morning.",
    "I've had this ice-cream bar since I was a child.",
    "Shut up or I will kill you.  I will physically kill you.",
    "Better stop before someone gets hurt.",
    "Whoa!!",
    "Jesus will love you if you give me money.",
    "Evil.  It's not just for breakfast anymore.",
    "XEvil.  The carpal tunnel game.",
    "Violence.  It's not just the best policy.  It's the only policy.",
    "Got ... to get ... to ... my arm.",
    "Who's the lucky one?",
    "Don't blink.  It would really suck if you blinked.",
    "Here kitty, kitty, kitty.",
    "Stay on target...",
    "Do not taunt Happy-Fun-Ball.",
    "Bring out the gimp.                            Gimp's sleepin.\nWell, I guess you'll just have to go wake him up now, won't you.",
    "That's easy.",
    "It's just a rabbit.",
    "Ignorance is the number one cause of happiness.",
    "What the heck's going on?  I thought I was a normal guy.",
    "Oh, no.  It's K-k-k-ken c-c-c-coming to k-k-k-kill me.",
    "You bloated sack of protoplasm.",
    "The weak exist only to amuse the strong.",
    "We're not hitch-hiking anymore.  We're riding.",
    "No, sir.  I didn't like it.",
    "Are we there yet?",
    "Kurt Cobain spoke for my generation.",
    "We're on a mission from God.",
    "Oh, I'm a lumberjack and I'm ok...",
    "I'm sorry.  You must have mistaken me for the clown that gives a damn.",
    "Another visitor.  Stay awhile.  STAY FOREVER!!!!",
    "I laughed.  I cried.  It was better than Cats.\nI'd see it again and again.",
    "SPOON!!!",
    "Only life can kill you.",
    "That which does not kill us, hurts.",
    "Hey, baby.  Wanna wrestle.",
    "Fuck you and the horse you rode in on.",
    "Spin, spin, spin, spin, spin, spin, spin...",
    "Dope will get you through times of no money\nbetter than money will get you through times of no dope.",
    "What he said.",
    "Like, take off, eh.",
    "Lord God, Leroy, that was the toughest meanest hippie I ever saw.",
    "Happy thoughts.  Happy thoughts. Happy thoughts.",
    "M*cr*s*ft:  Who need quality when you have marketing.",
    "The proof is left as an exercise.",
    "Ummm...  We have a problem.",
    "Come see the violence inherent in the system.\nHelp! Help! I'm being repressed.",
    "Hey, man, you a sniper?                                           Shut up.\nYou sure look like a sniper.                                      I said, shut up.",
    "Oh, I'm sorry.  Did that hurt?",
    "What me worry?",
    "Nobody expects the Spanish Inquisition!!!",
    "We are, we are, we are, we are, we are the engineers.\nWe can, we can, we can, we can demolish forty beers.",
    "When in doubt, shoot the lawyer.",
    "All that hate's gonna burn you up, boy.\nKeeps me warm.",
    "He lives in that piece of paper?\nNo, you idiot.  He lives in a regular house.",
    "I'll give you something to cry about.",
    "It's not a bug, it's a feature.",
    "Don't hate me because I'm beautiful.",
    "What a great game of cards this is.",
    "You're ugly and your mother dresses you funny.",
    "I can eat fifty eggs.",
    "What we have here is failure to communicate.",
    "Jesus loves me more than you.",
    "Are you threatening me!!!??",
    "I need TP for my bunghole.",
    "You're immune to both romance and mirth.  You must be a... a...\nThat's right.  I'm an engineer.",
    "Out Out!!  You demons of stupidity!!",
    "To infinity, and beyond!!!",
    "I love Bomb. It's nice.",
    "Marines!  We are leaving.",
    "Toad Sexing kicks ass.",
    "Let me try that again.",
    "I is a college graduate.",
    "FRIDAY!!! ... IN STEREO!!! ...",
    "I'll get you, my pretty.  And you're little dog, too!",
    "I think so, Brain, but can the marshmallow chicks and the gummy worms ever truly live at peace?",
    "It's cool to be a robot!",
    "We're here to chew bubble gum and kick ass--  and we're all out of bubble gum!",
    "HO HO HO!!  I'm here to EAT CANDY CANES and KICK ASS...\n  And I'm ALL OUT of CANDYCANES!  HO HO HO!",
    "Easy son...  you'll bleed slower if you calm down.",
    "Your father's soul says HI...  I just ATE HIM!",
    "I'M JESUS WITH A LASER GUN...  AND YOU'RE ALL GOING TO HELL!!",
    "OH MY GOD, THEY KILLED KENNY!\n   YOOOUUUU BASTARDS!",
    "Dude, this is pretty fucked up, right here..",
    "BIIIIIIIIIIRD-MAN!",
    "Biiird-BOY!",
    "My solar powers are recharging, Avenger.  Thank you, Ra, great spirit of the sun!",
    "I'll call him-  Moltar-boy!",
    "SPAAAAAAAAYYYCE  GHOOOOOOST!!",
    "I'm Zorak Ramone!\nI'm Moltar Ramone!",
    "You guys watch Joe Don Baker movies?!?",
    "Dude, don't say pig-fucker in front of Jesus!",
    "\"Does it involve wanton destruction?\"\n  \"We can only hope!\"",
    0,
};



char *Namer::intelNames[] = {
  "Dr. Pain",
  "Steve",
  "hardts",
  "James E. Tetazoo",
  "Arnold",
  "Victor the Cleaner",
  "Hudson",
  "Hicks",
  "Twinkie Boy",
  "Bob",
  "Ben Bitdiddle",
  "Beavis",
  "Butt-Head",
  "Fred",
  "Mulch-Man",
  "Mike",
  "Tim",
  "Peter",
  "Alan",
  "Neal",
  "Asshole",
  "Crazy Hairy",
  "Spaceman Spiff",
  "Kitty-Wench",
  "Juker",
  "Shrieks",
  "Albert Lin",
  "Jim Gouldstone",
  "Steph",
  "Paining",
  "Dim",
  "The Man",  
  "Twinkie Girl",
  "Mr. Buzzcut",  
  "Sensei Steve",
  "Ren",
  "Stimpy",
  "Mr. Horse",
  "Dilbert",
  "Dogbert",
  "Gromit",
  "The Tick",
  "Fat Freddie",
  "Phineas",
  "Freewheelin Franklin",
  "Doctor Who",
  "Celery-Head-Man",
  "Roo",
  "Shwang",
  "Leo",
  "Smoothie",
  "Hawaii Chick",
  "Cowboy Steve",
  "Outlaw Jim",
  "Prick",
  "Smack",
  "Hello, Kitty",
  "Wedge",
  "Redshirt",
  "Mistress Leah",
  "e^x Man",
  "John Rusnak",
  "Mr. Bonk",
  "Pixie of Pass/Fail",
  "Josh the 10-yr Old",
// ^-his-^  v-mine-v //
  "Tony Tastey",
  "Drywall",
  "Manji",
  "Seven of Nine",
  "Commander Ivanova",
  "Brak",
  "Zorak",
  "Moltar",
  "Moltar-Boy",   
  "Moltar Ramone",
  "Space Ghost",
  "Bird Man",
  "Hikaru \"Rick Hunter\" Ichijyo",
  "Joe-Don Baker",
  "Rob Schrab",
  "Katchoo",
  "Voodoo Ben", 
  "Dark Schneider",
  "Luche Len Len",
  "Arshes Nei",
  "Torgo",
  "Ortega",
  "Dr. Forrester",
  "TV's Frank",
  "Overfiend",
  "Fucknut",
  "Omlaut",
  "Long Dong Silver",
  "Akira",
  "Tetsuo",
  "Kaneda",
  "Jesus Christ",
  "Stan Marsh",
  "Kyle Broflofski",
  "Kenny McCormick",
  "Eric Cartman",
  "Mr. Hat",
  "Die Fledermaus",
  "Janet Reno",
  "Newt Gingrich",
  "Rush Limbaugh",
  "Pinky",
  "The Brain",
  "Neko",
  "Larry Wall",
  "Marie Curie",
  "Joan of Arc",
  "Lady Douchebag",
  "Richard Nixon",
  "Tentacle boy",
  "Uncle Scrotor",
  "Mike Nelson",
  "Dr. Smith",
  "Will Robinson",
  "Wilt Chamberlain",
  "Ra, great spirit of the sun",
  "Bill Clinton",
  "Hillary Clinton",
  0,
};


Namer::Namer()
{
   for(numnames=0; intelNames[numnames]!=0; numnames++);
   for(numsayings=0; wittySayings[numsayings]!=0; numsayings++);

   nameidx = new int[numnames];
   sayingidx = new int[numsayings];

   initnames();
   initsayings();
}


Namer::~Namer()
{
   delete nameidx;
   delete sayingidx;
}


void Namer::initnames()
{
   currname = numnames;
   Utils::randomList(nameidx, numnames);
}

void Namer::initsayings()
{
   currsaying = numsayings;
   Utils::randomList(sayingidx, numsayings);
}

int Namer::totalnames()
{
   return numnames;
}


int Namer::totalsayings()
{
   return numsayings;
}


char *Namer::get_name()
{
   if (currname < 1)
      initnames();
   return intelNames[nameidx[--currname]];
}


char *Namer::get_saying()
{
   if (currsaying < 1)
      initsayings();
   return wittySayings[sayingidx[--currsaying]];
}
